commit 67fcccd1716dc9b27566f4c2a321662de50a8cb9
Author: Milan Hotovec <silent@students.zcu.cz>
Date:   Mon May 10 17:23:55 2021 +0200

    Interfaces for repos

diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/ICommentRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/ICommentRepository.cs
index 4e47a70..3d9660b 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/ICommentRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/ICommentRepository.cs
@@ -1,4 +1,5 @@
 ﻿using ExtCore.Data.Abstractions;
+using Leuze.Modules.Goal.Domain.Domains;
 using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -9,5 +10,16 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 {
     public interface ICommentRepository : IRepository
     {
+        Task<bool> AddAsync(Comment comment);
+
+        Task<bool> RemoveAsync(Guid id);
+
+        Task<Comment> GetByIdAsync(Guid id);
+
+        Task<List<Comment>> GetAllForGoalAsync(Guid goalId);
+
+        Task<List<Comment>> GetAllAsync();
+
+        Task<bool> EditAsync(Guid id, string text);
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
index f744dc6..fd33a06 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalDefinitionRepository.cs
@@ -10,6 +10,22 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 {
     public interface IGoalDefinitionRepository : IRepository
     {
-        Task<GoalDefinition> GetByIdAsync(Guid id); 
+        Task<List<GoalDefinition>> GetAllForUserAsync(Guid userId);
+
+        Task<List<GoalDefinition>> GetAllAsync();
+
+        Task<GoalDefinition> GetByIdAsync(Guid id);
+
+        Task<bool> AddAsync(GoalDefinition gd);
+
+        Task<bool> RemoveAsync(Guid id);
+
+        Task<bool> SetVariAsync(Guid id, decimal vari);
+
+        Task<bool> SetFromAsync(Guid id, DateTime from);
+
+        Task<bool> SetToAsync(Guid id, DateTime to);
+
+        Task<bool> SetNameAsync(Guid id, string name);
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
index 48da67e..b5decb6 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalItemRepository.cs
@@ -12,5 +12,24 @@ namespace Leuze.Modules.Goal.Domain.Repositories
     {
 
         Task AddAsync(GoalItem item);
+
+        Task<bool> RemoveAsync(Guid id);
+
+        Task<GoalItem> GetByIdAsync(Guid id);
+
+        Task<List<GoalItem>> GetAllForUserDefinitionAsync(Guid definitionId);
+
+        Task<List<GoalItem>> GetAllAsync();
+
+        Task<bool> SetNameAsync(Guid id, string name);
+
+        Task<bool> SetDescriptionAsync(Guid id, string description);
+
+        Task<bool> SetPercentileUserAsync(Guid id, decimal percentile);
+
+        Task<bool> SetPercentileFinalAsync(Guid id, decimal percentile);
+
+        Task<bool> SetGoalDefinitionAsync(Guid id, Guid definitionId);
+
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalUpdateRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalUpdateRepository.cs
index 1010567..e975808 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalUpdateRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IGoalUpdateRepository.cs
@@ -1,4 +1,5 @@
 ﻿using ExtCore.Data.Abstractions;
+using Leuze.Modules.Goal.Domain.Domains;
 using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -9,5 +10,14 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 {
     public interface IGoalUpdateRepository : IRepository
     {
+        Task<bool> AddAsync(GoalUpdate update);
+
+        Task<bool> RemoveAsync(Guid id);
+
+        Task<GoalUpdate> GetByIdAsync(Guid id);
+
+        Task<List<GoalUpdate>> GetAllForGoalAsync(Guid goalId);
+
+        Task<List<GoalUpdate>> GetAllAsync();
     }
 }
diff --git a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IReviewRepository.cs b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IReviewRepository.cs
index 2591765..008cf15 100644
--- a/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IReviewRepository.cs
+++ b/src/Modules/Goal/Domain/Leuze.Modules.Goal.Domain/Repositories/IReviewRepository.cs
@@ -1,4 +1,5 @@
 ﻿using ExtCore.Data.Abstractions;
+using Leuze.Modules.Goal.Domain.Domains;
 using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -9,5 +10,14 @@ namespace Leuze.Modules.Goal.Domain.Repositories
 {
     public interface IReviewRepository : IRepository
     {
+        Task<bool> AddAsync(Review review);
+
+        Task<bool> RemoveAsync(Guid id);
+
+        Task<Review> GetByIdAsync(Guid id);
+
+        Task<List<Review>> GetAllForGoalAsync(Guid definitionId);
+
+        Task<List<Review>> GetAllAsync();
     }
 }